package rispec

/* TODO: add a cache for the command parser */

import (
	"strings"
	"reflect"
	"errors"
)

var (
	ErrBadCommand = errors.New("bad command")
)


type RtDecoration string

func (r RtDecoration) String() string {
	return "::"
}

type RtUnescapedString string

func (r RtUnescapedString) String() string {
	return "e"
}

type RtParameters string

func (r RtParameters) String() string {
	return "..."
}

/* below is a minimal set for RenderMan Interface; this is here for temporal develpment use
 * and will be replaced with a full machine generated version from the current ri.h
 */


/* FIXME: below should be moved to rispec and machine generated by parsing ri.h */

var All = []interface{}{RiAttributeBegin{},RiDeclare{},
															RiAttributeEnd{},RiAttribute{},RiBxdf{},RiDisplay{},RiFormat{},RiLight{},
															RiSphere{},RiWorldBegin{},RiWorldEnd{},RiFrameBegin{},RiFrameEnd{}}


const Commands string = "Declare,FrameBegin,Format,Display,WorldBegin,AttributeBegin,Attribute,Light,AttributeEnd,Sphere,Bxdf,WorldEnd,FrameEnd"


type RiStructPair struct {
	Name string
	Type string
}


type RiStructInformation struct {
	Name string
	Values []RiStructPair
	HasParameterlist bool	 	
}

func (ri *RiStructInformation) Size() int { 
	return len(ri.Values)
}


func FindRiCommand(command string) (*RiStructInformation,error) {

	st := &RiStructInformation{}
	st.Values = make([]RiStructPair,0)
	found := false

	for _,ric := range All {

		t := reflect.TypeOf(ric) 
		if t.NumField() > 0 {
			if t.Field(0).Name == "funcname" && t.Field(0).Tag.Get("rispec") == command {
				st.Name = t.Name()

				found = true

				for f := 1; f < t.NumField(); f++ {
				
					field := t.Field(f)

					switch field.Type.String() {
						case "RtParameters":
							st.HasParameterlist = true
						break
						case "RtDecoration":
							/* do nothing */
						break
						default: 
							spec := field.Tag.Get("rispec")
							if len(spec) > 0 {
								parts := strings.Split(spec,",")
								if len(parts) == 2 {
					
									st.Values = append(st.Values,RiStructPair{Name: parts[0], Type: parts[1]})
								}
							}
						break
					}
				}				
			}
		}

		if found {
			break
		}
	}

	if found {
		return st,nil
	}

	return nil,ErrBadCommand
}




type RiAttributeBegin struct {
	funcname RtDecoration `rispec:"AttributeBegin"`
}

type RiDeclare struct {
	funcname RtDecoration `rispec:"Declare"`
	Name RtString					`rispec:"name,string"`
	Spec RtToken					`rispec:"spec,string"`
}

type RiAttributeEnd struct {
	funcname RtDecoration `rispec:"AttributeEnd"`
}

type RiAttribute struct {
	funcname RtDecoration `rispec:"Attribute"`
	Name     RtToken      `rispec:"name,string"`

	params RtDecoration `rispec:"parameterlist"`
	Params RtParameters `rispec:"params"`
}

type RiBxdf struct {
	funcname RtDecoration `rispec:"Bxdf"`
	Name     RtToken      `rispec:"name,string"`
	Handle   RtToken      `rispec:"handle,string"`

	params RtDecoration `rispec:"parameterlist"`
	Params RtParameters `rispec:"params"`
}

type RiDisplay struct {
	funcname RtDecoration `rispec:"Display"`
	Name     RtString     `rispec:"name,string"`
	Type     RtToken      `rispec:"type,string"`
	Mode     RtToken      `rispec:"mode,string"`

	params RtDecoration `rispec:"parameterlist"`
	Params RtParameters `rispec:"params"`
}

type RiFormat struct {
	funcname RtDecoration `rispec:"Format"`
	Xres     RtInt        `rispec:"xres,int"`
	Yres     RtInt        `rispec:"yres,int"`
	Pixel_ar RtFloat      `rispec:"pixel_ar,float64"`
}

type RiLight struct {
	funcname RtDecoration `rispec:"Light"`
	Name     RtToken      `rispec:"name,string"`
	Handle   RtToken      `rispec:"handle,string"`

	params RtDecoration `rispec:"parameterlist"`
	Params RtParameters `rispec:"params"`
}

type RiSphere struct {
	funcname RtDecoration `rispec:"Sphere"`
	Radius   RtFloat      `rispec:"radius,float64"`
	Zmin     RtFloat      `rispec:"zmin,float64"`
	Zmax     RtFloat      `rispec:"zmax,float64"`
	Tmax     RtFloat      `rispec:"tmax,float64"`

	params RtDecoration `rispec:"parameterlist"`
	Params RtParameters `rispec:"params"`
}

type RiWorldBegin struct {
	funcname RtDecoration `rispec:"WorldBegin"`
}

type RiWorldEnd struct {
	funcname RtDecoration `rispec:"WorldEnd"`
}

type RiFrameBegin struct {
	funcname RtDecoration `rispec:"FrameBegin"`
	Frame    RtInt        `rispec:"frame,int"`
}

type RiFrameEnd struct {
	funcname RtDecoration `rispec:"FrameEnd"`
}
